//
//  ViewController.m
//  HelloAqTk2
//
//  Created by yamazaki on 2016/03/18.
//  Copyright © 2016年 AQUEST. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // AquesTalk2インスタンス生成
    m_pAqTk = AquesTalk2Da_Create();
    
    // Notificationの登録　発声終了を検知しなければ不要 メソッド名やnameは任意で
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(daDone:)
     name: @"AquesTalk2DaDoneNotify"
     object:nil];
}

- (void)dealloc {
    if(m_pAqTk) AquesTalk2Da_Release(m_pAqTk);
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction)play:(id)sender
{
    //終了通知イベントの作成　name部分はNSNotificationCenterに設定した値に合わせる
    NSNotification *notification = [NSNotification notificationWithName:@"AquesTalk2DaDoneNotify" object:self userInfo:nil];

    // テキストボックスから文字列取得し、文字コードをShiftJISに変換し、音声合成出力（非同期）
    char *sjis = (char*)[[textfield text] cStringUsingEncoding:NSShiftJISStringEncoding];
    int iret = AquesTalk2Da_Play(m_pAqTk, sjis, 100, nil, notification);

    if(iret!=0){ // エラーの場合はアラート表示
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"Error" message:@"音声記号列の指定が正しくありません" preferredStyle:UIAlertControllerStyleAlert];
        [alertController addAction:[UIAlertAction actionWithTitle:@"はい" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) { }]];
        [self presentViewController:alertController animated:YES completion:nil];
        return;
    }
    onPlayLabel.text = @"Playing...";
}

-(IBAction)stop:(id)sender
{
    AquesTalk2Da_Stop(m_pAqTk);
}
- (void)daDone:(NSNotification*)notification
{
    onPlayLabel.text = @"Done";
}

@end
